#ifndef QTMIGHTABILITY_H
#define QTMIGHTABILITY_H

#include <QWidget>

#include "qtLibrary.hpp"
#include "qtFormRobot/moverobot.hpp"
#include "qtMainInterface/mainwindow.hpp"

namespace Ui {
    class qtMightability;
}

class qtMightability : public QWidget {
    Q_OBJECT
public:
    qtMightability(QWidget *parent = 0);
    ~qtMightability();

    void setMainWindow(MainWindow *ptrMW) { m_mainWindow = ptrMW; }

protected:
    void changeEvent(QEvent *e);

private:
    std::vector<QString> FreeFlyers;
    std::vector<QString> Agents;
    MainWindow *m_mainWindow;

    Ui::qtMightability *ui;
    void initMightabilities();
    void initGui();

private slots:
    void on_pushButtonTaskability_clicked();
    void on_checkBox_toggled(bool checked);
    void on_pushButtonInitialiaze_clicked();
    void on_pushButtonPlanTask_clicked();
    void on_pushButtonExecuteAll_clicked();
};

#endif // QTMIGHTABILITY_H
