#ifndef QTPLACECAMERA_H
#define QTPLACECAMERA_H

#include <QDialog>


namespace Ui {
    class qtPlaceCamera;
}

class qtPlaceCamera : public QDialog {
    Q_OBJECT
public:
    qtPlaceCamera(QWidget *parent = 0);
    ~qtPlaceCamera();


protected:
    void changeEvent(QEvent *e);
    void initAll();

private:
    Ui::qtPlaceCamera *ui;

private slots:
    void on_horizontalSliderup3_sliderMoved(int position);
    void on_horizontalSliderup2_sliderMoved(int position);
    void on_horizontalSliderup1_sliderMoved(int position);
    void on_horizontalSliderup0_sliderMoved(int position);
    void on_horizontalSliderel_sliderMoved(int position);
    void on_horizontalSlideraz_sliderMoved(int position);
    void on_horizontalSliderdist_sliderMoved(int position);
    void on_horizontalSliderz_sliderMoved(int position);
    void on_horizontalSlidery_sliderMoved(int position);
    void on_horizontalSliderx_sliderMoved(int position);
    void on_doubleSpinBoxup3_valueChanged(double v);
    void on_doubleSpinBoxup2_valueChanged(double v);
    void on_doubleSpinBoxup1_valueChanged(double v);
    void on_doubleSpinBoxup0_valueChanged(double v);
    void on_doubleSpinBoxel_valueChanged(double v);
    void on_doubleSpinBoxaz_valueChanged(double v);
    void on_doubleSpinBoxdist_valueChanged(double v);
    void on_doubleSpinBoxz_valueChanged(double v);
    void on_doubleSpinBoxy_valueChanged(double v);
    void on_doubleSpinBoxx_valueChanged(double v);
    void on_pushButtonQuit_clicked();
    void on_pushButtonLoad_clicked();
    void on_pushButtonSave_clicked();

signals:
    void valueChanged();
};

#endif // QTPLACECAMERA_H
